# -*- coding: utf-8 -*-
"""

Einführung in Python: Typischer Aufbau eines Programms 
Datentypen, Typumwandlung, Arrays, Plotfunktionen

Created on 16.4. 2019
@author: philippsen
"""
# Zuerst werden die Pakete vollständig oder nur einzelne 
# Funktionen importiert!

import cmath
import numpy as np
import matplotlib.pyplot as plt

# Float-Variablen werden durch Zuweisung deklariert
Kp = 2.6        # z.B. Verstärkung
T1 = 0.2        # z.B. Zeitkonstante
print('Kp= 2.6 Datentyp Kp: ',type(Kp))

# Typumwandlung float nach int -> stets abrunden
K = int(Kp) 
print('K = int(Kp) = ',K,' Datentyp K: ',type(K))
Kr = round(Kp)  # Typumwandlung float nach int -> runden
print('Kr = round(Kp) = ',Kr,' Datentyp Kr: ',type(Kr))

# Komplexe Variablen ergeben sich oft im Verlauf einer Berechnung
a = cmath.sqrt(-2)
print('a = cmath.sqrt(-2) = ',a,' Datentyp a: ',type(a))

# Eine Deklaration eines Arrays, Vektors oder Matrix erfordert 
# das NumPy-Paket
N1  = np.array([T1, 1])
# Ein Array kann vorbelegt werden, hier mit aufsteigenden Zahlen
# von 0 bis 2pi mit dem Inkrement 0,01
time = np.arange(0.0, 2*np.pi, 0.01)
print('Datentyp time: ',type(time))
kk=np.size(time)
print('Anzahl Elemente time: ',np.size(time))

# Berechnung der Sinusfunktion
sinus = np.sin(time)

# Die Plotfunktionen stellt das Matplotlib-Paket zur Verfügung
# Erzeugung eines neuen Ausgabefensters mit plt.figure()
plt.figure()
# Plot der Sinus-Funktion über die Zeit:
plt.plot(time, sinus, "r") 
# Beschriftung der Achsen und des Titels:
plt.ylabel('sin t', color="red", fontsize=14) 
plt.xlabel('t [s]', fontsize=12) 
plt.title('Sinus', fontsize=12)
# Erzeugung eines Gitternetzes:
plt.grid(True)
