# -*- coding: utf-8 -*-
"""
Fast Fourier Transformation mit Python SciPy
Überlagerung von drei Sinussignalen 25, 50 und 50Hz 
sowie normalverteiltem Rauschen

Created on 1.10. 2018

@author: philippsen
"""

from scipy.fftpack import fft
import numpy as np
import matplotlib.pyplot as plt

k = 50000
TT = 10.
t  = np.linspace(0.0, TT,k)
y = 1.2*np.sin(100*np.pi*t)+ 0.8*np.sin(200*np.pi*t)+ \
    0.6*np.sin(50*np.pi*t) + np.random.normal(size=k)

ff = fft(y)
f = np.linspace(0.0,k/(2*TT),k//2)
z = 2.0/k*np.abs(ff[0:k//2])
plt.subplot(2,1,1)
plt.plot(t,y)
plt.title('25 +50 + 100 Hz + Rauschen')
plt.ylabel('y(t)')
plt.xlabel('t [s]')
plt.grid('true')
plt.subplot(2,1,2)
plt.plot(f,z)
plt.xlim(0,120)
plt.xlabel('f in Hertz')
plt.ylabel('Betrag Spektrum')
plt.grid('true')
