# -*- coding: utf-8 -*-
"""

Standardregelstrecke mit PI-Regler Beispiel 3.4

Created on 21.3. 2019
@author: philippsen
"""

import numpy as np
import control
from  control.matlab import * # Funktionen sind ohne Präfix nutzbar 
import matplotlib.pyplot as plt

a0 = 1.; a1 = 10. ; a2 = 31. ; a3 = 30.
b0 = 1.
num  = np.array([b0])
den  = np.array([a3, a2, a1, a0])

strecke = tf(num,den)
#regler = tf([5, 1],[5, 0])
regler = tf([5],[1])
G0 = regler*strecke  # Reihenschaltung R(s) und G(s)

bode(G0)

Gw = feedback(G0, 1) 

bode(Gw)
gm, pm, wg, wp = control.matlab.margin(G0)
gmdb = 20*np.log10(gm); wphz = wp/(2*np.pi)
print('Amplitudenreserve = ',gm,' in dB = ',gmdb)
print('Phasenreserve = ',pm)
print('Durchtrittsfrequenz = ',wp,' in Hertz = ',wphz)
plt.figure()
y, t = control.matlab.step(Gw)
plt.plot(t,y)
plt.title('Regelkreis')
plt.xlabel('t [s]'); plt.ylabel('h(t)')
plt.grid()
plt.show()
plt.figure()
real, imag, ww = control.matlab.nyquist(G0) 
plt.plot(real,imag)
plt.title('Ortskurve')
plt.xlabel('Real'); plt.ylabel('Imag')
plt.grid(True)