# -*- coding: utf-8 -*-
"""
Fahrzeug Querdynamik Lenkmodell
Created on 27.1. 2020
@author: philippsen
nach 10 Sek wird Lenkwinkel auf null gestellt
"""

from scipy.integrate import odeint
import numpy as np
import matplotlib.pyplot as plt

def deriv(xa, t, alpha):
    beta=xa[0]
    #x = xa[1]; z = xa[2]
    v = 0.79
    Rs = 0.5
    bp = np.sin(alpha)*v/Rs
    xp = v*np.sin(alpha + beta)
    zp = v*np.cos(alpha + beta)
    xapunkt = [bp, xp, zp]
    return xapunkt

time = np.arange(0.0, 10.0, 0.01)
xaAnfang = [0,0,0]
u = 0.2

xa = odeint(deriv, xaAnfang, time, args=(u,))
xb = odeint(deriv, xa[999,:], time, args=(0,))
plt.figure()
plt.plot(xa[:,2],xa[:,1]  ) #
plt.plot(xb[:,2],xb[:,1]  )
plt.axis('scaled') 
plt.ylabel('x', fontsize=14) 
plt.xlabel('z', fontsize=14) 
plt.title('Lösung Lenkung-DGL mit Python')
plt.grid()