# -*- coding: utf-8 -*-
"""
Ortskurven, h(t) Standardregelstrecke und PI-Regler

Created on 21.3. 2019, mod 15.4.24
@author: philippsen
"""

import numpy as np
import control
from  control.matlab import *
import matplotlib.pyplot as plt

a0 = 1.; a1 = 10. ; a2 = 31. ; a3 = 30.
b0 = 1.
num  = np.array([b0])
den  = np.array([a3, a2, a1, a0])

strecke = control.matlab.tf(num,den)
regler = 1.0
G0 = regler*strecke
real, imag, ww = control.matlab.nyquist(G0) #,Plot=False)
plt.plot(real, imag, "b")
real, imag, ww = control.matlab.nyquist(2*G0) #,Plot=False)
plt.plot(real, imag, "r")
real, imag, ww = control.matlab.nyquist(4*G0) #,Plot=False)
plt.plot(real, imag, "g")
plt.title('Ortskurven')
plt.grid()
plt.show()
plt.figure()
Gw = feedback(G0, 1) #   Kreis
xx, tt = control.matlab.step(Gw)
plt.plot(tt,xx,"b")
Gw = feedback(2*G0, 1) #   Kreis
xx, tt = control.matlab.step(Gw)
plt.plot(tt,xx,"r")
Gw = feedback(4*G0, 1) #   Kreis
xx, tt = control.matlab.step(Gw)
plt.plot(tt,xx,"g")
plt.title('Regelkreis')
plt.xlabel('t [s]'); plt.ylabel('x(t)')
plt.grid()
plt.show()
#plt.gcf().clear() # So wird Plot gelöscht