# -*- coding: utf-8 -*-
"""
Standardregelstrecke  G(s) Betragsoptimum

Created on 27.1. 2020
@author: philippsen
"""

import numpy as np
#import control
from  control.matlab import *
import matplotlib.pyplot as plt

a0 = 1.
a1 = 10.
a2 = 31.
a3 = 30. ; a4 =0; a5 = 0
b0 = 1.
num  = np.array([b0])
den  = np.array([a3, a2, a1, a0])
strecke = tf(num,den)
D =np.linalg.det([[a1, -a0, 0],
 	    [a3, -a2, a1],
	    [a5, -a4, a3]])

r0=np.linalg.det([[a0**2,   -a0, 0],
 	 [(-a1**2 + 2*a0*a2),    -a2, a1],
	 [(a2**2  + 2*a0*a4 -2*a1*a3),-a4, a3]])
r0 = r0/D

r1=np.linalg.det([[a1,   a0**2,		0],
 	  [a3, 	(-a1**2 + 2*a0*a2),	 	a1],
	  [a5,	(a2**2  + 2*a0*a4 -2*a1*a3),	 a3]])
r1 = r1/D

r2=np.linalg.det([[a1,    -a0,	 a0**2],
 	  [a3, 	-a2,	(-a1**2 + 2*a0*a2) ],
	  [a5,	-a4,	(a2**2  + 2*a0*a4 -2*a1*a3)]	])
r2 = r2/D

kr = r1/2
tn = r1/r0
tv = r2/r1 ; t1 = tv/5.0
#regler = tf([kr*tn*tv, kr*tn, kr],[tn, 0]) # ohne D-T1
regler = tf([kr*(tv+t1)*tn, kr*(tn+t1), kr],[tn*t1, tn, 0])
regelkreis = feedback(regler*strecke,1)
x, t = step(regelkreis)

stell = feedback(regler, strecke)
y, t = step(stell)

fig, ax1 = plt.subplots()

ax1.plot(t, x, "b") 
ax1.set_ylabel('x', color="blue") 
plt.grid()
plt.plot([0, 36], [0.97, 0.97], '--',color="blue")
plt.plot([0, 36], [1.03, 1.03], '--',color="blue")
ax2 = ax1.twinx() 
ax2.plot(t, y, "r") 
ax2.set_ylabel('y', color="red") 
ax1.set_xlabel('t [s]', fontsize=12) 
plt.title('Entwurf gemäß Betragsoptimum, Tol. +-3%')
