# -*- coding: utf-8 -*-
"""
Created on 4.1.22     IT1-Strecke
PI-Regler und PDT1 als extra Rückführung
@author: philippsen
"""
import control as ct
import numpy as np
import matplotlib.pyplot as plt
plt.rcParams['pdf.fonttype'] = 42
plt.rcParams['ps.fonttype'] = 42

K=1; T1 = .2
strecke = ct.tf2io(ct.tf(K, [T1, 1.0, 0.0]), inputs='y', outputs='xs')
Kr = 0.7; Tn = 0.6261
piregler = ct.tf2io(ct.tf([Kr*Tn, Kr], [Tn, 0.0]), inputs='e', outputs='ypi')
sumblk = ct.summing_junction(inputs=['w', '-xs'], output='e')
r1 =  2*np.sqrt(T1/K)-1/K
Tf = abs(r1)/10
pdt1 = ct.tf2io(ct.tf([Tf+r1, 1.0], [Tf, 1.0]), inputs='xs', outputs='yd')
sumblk2 = ct.summing_junction(inputs=['ypi', '-yd'], output='y')

#Regelkreis aufbauen
Rk = ct.interconnect([strecke, pdt1,
    piregler, sumblk, sumblk2], inplist='w', outlist=['xs','y'])

T = np.arange(0.0, 10.0, 0.01) # Simulationsdauer und T0 

ww = np.ones([len(T)]) # Eingangsgröße

t, yy = ct.input_output_response(Rk, T, ww)

# Plot Regelkreis-Sprungantwort
plt.figure(1)
plt.plot(t,yy[0,:],t,yy[1,:])
plt.xlabel('t [s]');plt.ylabel('y (rot) , x (blau)')
plt.title('Sprungantwort I-T1 mit PI und Lead')
plt.grid()

