# -*- coding: utf-8 -*-
"""
Standardregelstrecke im Zustandsraum in RNF
Created on 12.4. 2019
@author: philippsen
"""

import numpy as np
import control
from  control.matlab import *
from matplotlib.pyplot import *
import matplotlib.pyplot as plt

a0 = 1./30.
a1 = 10./30.
a2 = 31./30.
b0 = 1./30.
A  = np.array([[0, 1.,0 ],[ 0, 0, 1. ],[ -a0, -a1, -a2]])
b  = np.array([[0.],[ 0. ],[ 1.]])
c  = np.array([b0, 0,0 ])
stand = ss(A, b, c, 0)

y, t = control.matlab.step(stand)

plt.plot(t,y)
plt.title('Standardregelstrecke im Zustandsraum')
plt.xlabel('t [s]'); plt.ylabel('h(t)')    
plt.grid()
