# -*- coding: utf-8 -*-
"""

DC-Motor  im Zustandsraum  Faulhaber Motor 2237
Created on 16.10. 2018
@author: philippsen
"""

import numpy as np; from math import pi
import control
from   control.matlab import *
import matplotlib.pyplot as plt

cPsi= 0.0318    #   Datenblatt Faulhaber 2237
R = 15.7        # Widerstand Anker
L = 590e-6        # Induktivität Anker
zpiJ = 47.119e-6 #	Schwungmasse Berechnung 2pi7,5e-6
   
Am  = np.array([[-R/L,  -2*pi*cPsi/L],
                [cPsi/zpiJ, 0]])
bm  = np.array([[ 1/L],[0]])
cm  = np.array([ 0, 1])
C  = np.array([[1, 0 ],
                [0, 1 ]])   # Falls alle Zustände ausgegeben werden sollen
D  = np.array([[ 0. ],[0]])
DCmot = ss(Am, bm, cm, 0)

y, t = control.matlab.step(DCmot)

plt.gcf().clear() # löscht den alten Plot
plt.plot(t,y)
plt.title('DC-Motor im Zustandsraum')
plt.xlabel('t [s]'); plt.ylabel('n(t)')    
plt.grid()
