# -*- coding: utf-8 -*-
"""

Standardregelstrecke im Zustandsraum und Transformation auf RNF
Steuerbarkeitsmatrix S, Vergleich mit Control Toolbox

Created on 25.4. 2019
@author: philippsen
"""

import numpy as np
import control
from  control.matlab import *
from matplotlib.pyplot import *
import matplotlib.pyplot as plt

T1 = 2; T2 = 3; T3 = 5

A  = np.array([[-1/T1, 0.,0 ],[ 1/T2, -1/T2, 0 ],[ 0, 1/T3, -1/T3]])
b  = np.array([[1/T1],[ 0. ],[ 0]])
c  = np.array([0, 0,1 ])
stand = ss(A, b, c, 0)
# Berechnung Transformationsmatrix auf RNF
n = np.size(b)
AA = A
S = np.zeros((n,n));    T = np.zeros((n,n))
S[:,0] = b.T
S[:,1] = np.dot(A,b).T  # Aufbau Steuerbarkeitsmatrix
for i in range(2,n):
    AA = np.dot(AA,A)
    S[:,i] = np.dot(AA,b).T

S1 = np.linalg.inv(S)
T[0,:] = S1[n-1,:]      #letzte Zeile Übernehmen
for i in range(1,n):
    T[i,:] = np.dot(T[i-1,:],A).T

print('T = ')
print(T,'\n')
Arnf = np.mat(T)*np.mat(A)*np.linalg.inv(T)
print('Arnf = ')
print(Arnf,'\n')
zu = ss(A,b,c,0.0)
Arnf2, T2 = control.canonical_form(zu)
print('System mit Control Toolbox auf RNF transformiert:')
print(Arnf2)