# -*- coding: utf-8 -*-
"""

Modellreduktion Standardregelstrecke
Created on 4.1. 2022
@author: philippsen
"""

import numpy as np
from   control.matlab import *
import matplotlib.pyplot as plt
plt.rcParams['pdf.fonttype'] = 42
plt.rcParams['ps.fonttype'] = 42

g3 = tf(1,[30, 31, 10, 1])  # Standardregelstrecke
s3 = tf2ss(g3)

x,t = step(g3)
plt.figure(1)
plt.plot(t,x)

b2 = balred(s3,2, method='matchdc') 
#b2 = balred(s3,2, method='truncate') #
gb2 = ss2tf(b2)
print('G(s) = ',gb2)
print(pole(gb2))
xx,t = step(b2,t)
plt.plot(t,xx)

plt.title('Standardregelstrecke und balred Ersatzmodell')
plt.xlabel('t [s]')
plt.ylabel('x')
plt.grid()

g2 = tf(1,[25,10,1]) #Ersatzmodell 2. Ordnung T1=T2=5
xxx,t = step(g2,t)
plt.figure(2)
plt.plot(t,x,t,xxx)
plt.title('Standardregelstrecke und P-T2 Ersatzmodell')
plt.xlabel('t [s]')
plt.ylabel('x')
plt.grid()
