# -*- coding: utf-8 -*-
"""
# Algorithmus PI-Regler und Simulation Sprungantwort
Created on 29.10. 2018
@author: philippsen
"""

import numpy as np
import control
# from   control.matlab import *
import matplotlib.pyplot as plt

# Parameter zeitkontinuierlicher Regler
kp = 2; tn = 1.5
t0 = 0.1 # Abtastzeit

# Diskretisierung
d0 = kp*(t0/(tn*2) + 1);    d1 = kp*(t0/(tn*2) - 1)

# Eingangsgröße
e = 1;  y = np.zeros(21)
e1 = 0  # Setzen der Anfangswerte

# Berechnung der Stellgröße
for i in range(1, 21):
    y[i] = y[i-1] + d0*e + d1*e1
    y1 = y[i]
    e1 = e

t=np.arange(0,2+t0,t0)
plt.step(t,y,where='pre')
plt.xlabel('k*T0'); plt.ylabel('y(k)')
plt.grid(True)
