# -*- coding: utf-8 -*-
"""
Diskretisierung P-T1 mit Toolbox und Tustin
Created on 2.4. 2019
@author: philipp
"""

import numpy as np
import control
from control.matlab import *
import matplotlib.pyplot as plt

den  = np.array([3, 1])
pt1 = tf(1,den)
y, t = control.matlab.step(pt1)

plt.plot(t,y)

t0 = 1 # Abtastzeit 
diskPT1=control.c2d(pt1,t0,'tustin')

tt=np.arange(0,t.max(),t0)
t1, y = control.step_response(diskPT1,tt)
plt.step(t1,y,where='post')
plt.xlabel('t [s] und k'); plt.ylabel('h(t) und h(k)')
plt.grid(True)
