# -*- coding: utf-8 -*-
"""
Diskretisierung  mittels bilinearer Transformation 
System 2. Ordnung mit der Übertragungsfunktion 
 
           b2s^2 + b1s + b0            db2 + db1z + db0z^2 
 G(s) = -------------------     G(z) = --------------------- 
           a2s^2 + a1s + a0            da2   + da1z + z^2 

Created on 29.10. 2018
@author: philippsen
"""

import numpy as np
import control
# from   control.matlab import *
import matplotlib.pyplot as plt
  
b2 = 1;  b1 = 0.01;  b0 = 1; a2 = 1; a1 = 1; a0 = 1 

t0 = 0.01   # Abtastzeit
  
db2 = (b0 - 2*b1/t0 + 4*b2/(t0*t0))/(a0 + 2*a1/t0 + 4*a2/(t0*t0))
db1 = (2*b0 - 8*b2/(t0*t0))/(a0 + 2*a1/t0 + 4*a2/(t0*t0))
db0 = (b0 + 2*b1/t0 + 4*b2/(t0*t0))/(a0 + 2*a1/t0 + 4*a2/(t0*t0))
  
da2 = (a0 - 2*a1/t0 + 4*a2/(t0*t0))/(a0 + 2*a1/t0 + 4*a2/(t0*t0))
da1 = (2*a0 - 8*a2/(t0*t0))/(a0 + 2*a1/t0 + 4*a2/(t0*t0))
  
dz = np.array([db0, db1, db2])
dn = np.array([1,   da1, da2])
dnotch = control.tf(dz,dn,t0)
#t=np.arange(0,4,t0)
#t1, y = control.step_response(dnotch,t)
#plt.step(t1,y[0],where='post')

notch2 = control.tf([b2, b1, b0],[a2, a1, a0])
dnotch2 = control.sample_system(notch2,t0,method='tustin')	# Diskretisierung
# Vergleich Formel mit Python-Funktion
print('Diskretisierung mit Formel = ',dnotch)
print('Diskretisierung mit Python Funktion = ',dnotch2)
