# -*- coding: utf-8 -*-
"""
Trapez Profil v, Fahrkurve Weg
Created on 16.10. 2018
@author: philippsen
"""

import numpy as np
import matplotlib.pyplot as plt
n = 400; s0 = 10.0; TH = 10; TVS = 2.5
v0 = s0/(TH - TVS)		
T0 = TH/n
x  = np.zeros(n+1); v = np.zeros(n+1) ; a = np.zeros(n+1); r = np.zeros(n+1)
tt = np.linspace(0,TH,n+1)

# (* Anfangswerte setzen*)
s1 = 0;	s2 = 0;	s3 = 0; 	str = 0

for k in range(1,n+1):
    tk = k*T0
    if tk <= TVS :
        s1 = tk*tk*s0/(2*TVS*(TH - TVS))
    elif tk <= (TH - TVS) :
        s2 = (tk - TVS)*v0	
    elif tk <= TH :
        s3 = (TVS*TVS - (tk - TH)*(tk - TH))*s0/(2*TVS*(TH - TVS)) 
    x[k]= s1 +  s2 + s3
    
for k in range(1,n):
    v[k] = (x[k+1]-x[k])/T0 # ableiten

for k in range(1,n):
    a[k] = (v[k+1]-v[k])/T0

plt.subplot(3,1,1) 
plt.plot(tt,x)
plt.ylabel('Weg x'); plt.grid(True)
plt.subplot(3,1,2) 
plt.plot(tt,v)
plt.ylabel('Geschwindigkeit'); plt.grid(True)
plt.subplot(3,1,3) 
plt.plot(tt,a)
plt.ylabel('Beschleunigung'); plt.grid(True)
plt.xlabel('Zeit in Sek'); plt.grid(True)

#p= a*v #Leistung
#plt.plot(tt,p)
#plt.plot(a,v)
#from scipy.fftpack import fft
#ff = fft(a)
#z = 2.0/n*np.abs(ff[0:n//2])
#plt.plot(z)