# -*- coding: utf-8 -*-
"""
sin^2 Profil
Created on 12.4. 2019

@author: philippsen
"""

from math import sin, pi
import numpy as np
import matplotlib.pyplot as plt
n = 200; s0 = 10.0; TH = 10; TA = 3.5
v0 = s0/(TH - TA)		
w = pi/(2*TA)
T0 = TH/n
x  = np.zeros(n+1); v = np.zeros(n+1) ; a = np.zeros(n+1); r = np.zeros(n+1)
tt = np.linspace(0,TH,n+1)

# (* Anfangswerte setzen*)
s1 = 0;	s2 = 0;	s3 = 0; 	str = 0

for k in range(1,n+1):
    tk = k*T0
    if tk <= TA :
        s1 = (tk/2 -  (1/(4*w))*sin(2*w*tk))*v0
    elif tk <= (TH - TA) :
        s2 = (tk - TA)*v0	
    elif tk <= TH :
        s3 = ((tk - TH + 2*TA)/2 - (1/(4*w))*sin(2*w*(tk - TH + 2*TA)))*v0 - s1
    x[k]= s1 +  s2 + s3
    
for k in range(1,n):
    v[k] = (x[k+1]-x[k])/T0 # ableiten

for k in range(1,n):
    a[k] = (v[k+1]-v[k])/T0
for k in range(1,n):
    r[k] = (a[k+1]-a[k])/T0

plt.subplot(4,1,1) 
plt.plot(tt,x)
plt.ylabel('Weg x'); plt.grid(True)
plt.subplot(4,1,2) 
plt.plot(tt,v,'y')
plt.ylabel('Geschwindigkeit'); plt.grid(True)
plt.subplot(4,1,3) 
plt.plot(tt,a,'g')
plt.ylabel('Beschleunigung'); plt.grid(True)
plt.subplot(4,1,4) 
plt.plot(tt,r,'r')
plt.xlabel('Zeit in Sek')
plt.ylabel('Ruck'); plt.grid(True)

p= a*v #Leistung
plt.figure()
plt.plot(tt,p)
plt.xlabel('Zeit in Sek')
plt.ylabel('Leistung')
#from scipy.fftpack import fft
#ff = fft(a)
#z = 2.0/n*np.abs(ff[0:n//2])
#plt.plot(z)